﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Globalization;
using System.Reflection;

namespace Lo344dataread
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                Type tServiceManager = Type.GetTypeFromProgID("com.sun.star.ServiceManager", true);
                object servicemanager = System.Activator.CreateInstance(tServiceManager);
                object desktop = servicemanager.GetType().InvokeMember("createinstance", BindingFlags.InvokeMethod, null, servicemanager, new object[] { "com.sun.star.frame.Desktop" });
                object doc = desktop.GetType().InvokeMember("getCurrentComponent", BindingFlags.InvokeMethod, null, desktop, new object[] { });
                object sheets = doc.GetType().InvokeMember("getSheets", BindingFlags.InvokeMethod, null, doc, new object[] { });
                object sheet = sheets.GetType().InvokeMember("getByIndex", BindingFlags.InvokeMethod, null, sheets, new object[] { 0 });
                object crange = sheet.GetType().InvokeMember("getCellRangeByPosition", BindingFlags.InvokeMethod, null, sheet, new object[] { 0, 0, 1, 1 });
                object cursor = sheet.GetType().InvokeMember("createCursorByRange", BindingFlags.InvokeMethod, null, sheet, new object[] { crange });
                try
                {
                    object data = cursor.GetType().InvokeMember("getDataArray", BindingFlags.InvokeMethod, null, cursor, new object[] { });
                    System.Console.WriteLine("Everything is OK. I guess you have 3.4.3 or older!");
                }
                catch
                {
                    System.Console.WriteLine("getDataArray FAILED!!! I guess you have LibreOffice 3.4.4 or newer!");
                }
            }
            catch
            {
                System.Console.WriteLine("You must have some testing workbook with at least 1 sheet open in Calc!");
            }
            System.Console.WriteLine();
            System.Console.WriteLine("Please press a key to close...");
            System.Console.ReadKey();
        }
    }
}
